local json = require("json")
local utils = require("utils")
local pl_utils = require("pl.utils")
local request_method = ngx.var.request_method

utils.check_login()
utils.check_permission("GatewayManage")

-- ip -4 maddress | awk '{i = 2; for (; i <= NF; i++){ if (index($(i),".") == 0) {printf "%s\n",$(i)}}}'
local function get_netcard_list()
    local cmd = "/usr/sbin/ip -4 maddress | awk '{i = 2; for (; i <= NF; i++){ if (index($(i),\".\") == 0) {printf \"%s \",$(i)}}}'"
    local res, actual, stdout, errout = pl_utils.executeex(cmd, false)
    if res then
        return utils.split_str(stdout, " ")
    end

    return {}
end

local function get_netcard_state(cardname)
    local cmd = 'ping -c 1 8.8.8.8 -I ' .. cardname
    local ok, retcode, _, _ = utils.call_shell(cmd)
    if (0 == retcode) then
        return "Interneting"
    end

    return "Linking"
end


if ("GET" == request_method) then

    local res = {}
    res["List"] = {}

    local net_list = get_netcard_list()

    -- LinkState, [Close, Offline, Linking, Interneting]
    for _, cardname in ipairs(net_list) do
        local carditem = {}
        carditem["CardName"] = cardname
       	if cardname == "lo" then
		carditem["LinkState"] = "Linking" 
	else
		carditem["LinkState"] = get_netcard_state(cardname)
	end
        table.insert(res["List"], carditem)
    end

    res_raw = json.encode(res)
    utils.error_exit(200, res_raw)

end


utils.error_exit(400, "unsupported request method")
------ EOF ------
