#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import sys

sys.path.append("../../lib/")
from leda_python import leda
from leda_python.mbus import MbusBase
import logging
import json
import time
import os
import uuid
import threading

_logger = logging.getLogger(__name__)


def createThread(task, args=()):
    t = threading.Thread(target=task, args=args)
    t.setDaemon(True)
    t.start()


def Task_event(obj):
    id = 0
    while (1):
        id = (id + 1) & 0xFFFF
        obj.reportEvent('event', {'MsgId': id})
        time.sleep(0.05)


def Task_event2(obj):
    while (1):
        obj.reportEvent('event2', {'MsgId': 'jys'})
        time.sleep(0.05)


class Demo_device(leda.BaseDeviceCallback):
    def __init__(self):
        self.name = "jys"

    def callService(self, name, input):
        if (name == 'method_1'):
            _logger.info('methdo_1 is called...')
            retInfo = 0, {'args': 'no time out'}

        else:
            time.sleep(5)
            _logger.info('other method is called @@@@@@@@@@@@@@@@@@@@@@@@@@')
            retInfo = 0, {'arg': 'time out'}
        return retInfo


if (__name__ == "__main__"):
    logging.basicConfig(level=logging.DEBUG,
                        format='%(asctime)s-%(threadName)-9s-%(filename)s[line:%(lineno)d]-%(levelname)s: %(message)s')
    driverObj = leda.LedaModule()
    driverObj.moduleInit('jys')
    device_name = 'test'
    product_key = 'test'
    deviceObj = driverObj.deviceRegister(device_name, product_key, "{\"name\": 123}", Demo_device())
    createThread(Task_event, (deviceObj,))
    createThread(Task_event2, (deviceObj,))
    while (1):
        deviceObj.online()
        time.sleep(1)
